
#ifndef __DIB_H__
#define __DIB_H__

#include <windows.h>

#define SAFE_PSET
#define SAFE_HLINE

class CBaseDIB
{
private:
	BITMAPINFO BmInfo;
	BITMAPINFOHEADER BmInfoHed;
	int pitch;
	LPBYTE lpBMP;
	LPBYTE lpWIDBMP;//̗\rbg}bv
	BOOL IsCreate;
	HDC hDC;
	HBITMAP hBmp,hOldBmp;
private:
	Swap2U(int &a,int &b);
	Swap2PYU(POINT &a,POINT &b);
	Swap2PXU(POINT &a,POINT &b);
	Sort3PYU(POINT &a,POINT &b,POINT &c);
	Endian(DWORD &a);
	Endian(WORD &a);

private:
	int i_Point(int x,int y)const;

	i_Pset(int x,int y,int color);

	i_HLine(int y,int a,int b,int color);

	int i_LoopPoint(int x,int y)const;	
	i_TilePset(int x,int y,const CBaseDIB &oth);

	i_PsetAlpha(int x,int y,int alpha,int color);

	i_Create(BITMAPINFOHEADER bmi);

public:

	//n

	CBaseDIB();
	CBaseDIB(int width,int height);
	virtual ~CBaseDIB();
	const CBaseDIB &operator=(const CBaseDIB &oth);
	Create(int width,int height);
	Destroy();
	int GetWidth()const;
	int GetHeight()const;
	WidthLine(int y);
	LoadBitmap(const char *filename,const int bitcount=32);
	LoadBitmapAndAlpha(const char *rgbfilename,const char *alphafilename,const int bitcount=32);

	//hԂ
	Fill(int color);

	//DCɕ`
	DIBtoDevice(HDC hdc)const;

	//]
	Rotate(const double x,const double y,const double angle);

	//90x݂̉]
	Rotate90(const int rang);

	//gk
	Scale(const double x,const double y);

	//gk
	ScaleTo(const int cx,const int cy);

	/////////////////////////////////////////////
	//Putn

	//`Put. x2,y2:disť_W
	PutRect(int x0,int y0,int x1,int y1,const CBaseDIB &oth,int x2=0,int y2=0);
	//`Put. x2,y2:srč_W
	PutFixRect(int x0,int y0,int x1,int y1,const CBaseDIB &oth,int x2=0,int y2=0);
	//`Put. x2,y2:srč_W JԂȂ
	PutFixRectFast(int x0,int y0,int x1,int y1,const CBaseDIB &oth,int x2=0,int y2=0);
	//_. x2,y2:srč_W
	TilePsetFreq(int x,int y,const CBaseDIB &oth,int x2,int y2);
	//At@Put
	PutAlpha(int x,int y,int alpha,const CBaseDIB &oth);
	//At@œ_
	PsetAlpha(int x,int y,int alpha,int color);

	//levelȏ̃At@`
	PutBAlpha(int x,int y,int level,const CBaseDIB &oth);
	PutFixBAlphaRect(int x0,int y0,int x1,int y1,int level,const CBaseDIB &oth,int x2=0,int y2=0);
	//levelȉ̃At@`
	PutCAlpha(int x,int y,int level,const CBaseDIB &oth);

	//o
	TextOut(int x,int y,char *str,int height=16,int width=8,int color=0x00ffffff,HFONT hfont=0,CBaseDIB *res=0);

	/////////////////////////////////////////////
	//P`n

	int Point(int x,int y)const;
	Pset(int x,int y,int color);
	HLine(int y,int a,int b,int color);
	Rectangle(POINT a,POINT b,int color);
	Triangle(POINT a,POINT b,POINT c,int color);
	Line(POINT a,POINT b,int color);

	HLineAlpha(int y,int a,int b,int color);
	RectangleAlpha(POINT a,POINT b,int color);
	LineAlpha(POINT a,POINT b,int color);

	int LoopPoint(int x,int y)const;	
	TilePset(int x,int y,const CBaseDIB &oth);
	TileHLine(int y,int a,int b,const CBaseDIB &oth);
	TileTriangle(POINT a,POINT b,POINT c,const CBaseDIB &oth);
	TileLine(POINT a,POINT b,const CBaseDIB &oth);
};


#endif

