
#ifndef __MESH_LOADER_H__
#define __MESH_LOADER_H__

#include <string>
#include <fstream>

#include "Mesh.h"
#include "Motion.h"

namespace Rydot
{

class Model;
class Mesh;
class Face;
class Material;
class Pose;
class Motion;

class IModelLoader
{
protected:
	std::istream *i;
	bool correct;
public:
	IModelLoader():i(NULL),correct(false){}
	virtual ~IModelLoader(){if(i)delete i;}
	bool IsCorrect(){return correct;}
protected:
	//g[NǂݏoB
	//ƂẮAoCI[VXy[XA^uAsAJbRƂāA
	//oCI[VȊÔ̂ÃoCI[V܂łǂݏoA
	//oCI[VʒuɃ|C^u
	//ex. \t1\t2AAA(3 ptr:(3
	int ReadToken(std::string &s)
	{
		int n=0;
		while(1)
		{
			char c;
			c=i->peek();
			if(c==' '||c=='\t'||c=='\n'||c=='\r'||c=='('||c=='{')
			{if(n)return 0;}
			else{n++;s+=c;}
			i->get(c);	
		}
	}
	//ǂݏoB
	//ƂẮA_uNH[e[Vɋ܂ꂽ̈ǂݏoA
	//̃_uNH[e[V1Ƀ|C^u
	//ex.  123"AAA"456 ptr:4
	int ReadLit(std::string &s)
	{
		int n=-1;
		while(1)
		{
			char c;
			c=i->peek();
			if(c=='\x22')// "
			{
				if(n>=0){i->get(c);return 0;}
				else n=0;
			}
			else if(n>=0){n++;s+=c;}
			i->get(c);
		}
	}
	//end܂ŃXLbv
	int SkipPreChar(char end)
	{
		while(1)
		{
			char c;
			i->get(c);
			if(c==end){return 0;}
		}
	}
	//Xy[XE^uEs΂
	int SkipSpace()
	{
		int n=0;
		while(1)
		{
			char c;
			c=i->peek();
			if(c==' '||c=='\t'||c=='\n'||c=='\r');
			else{return 0;}
			i->get(c);	
		}
	}
	//JbR{}Ɉ͂܂ꂽ̈ǂݍ
	int ReadBlock(std::string &s)
	{
		int n=-1;
		while(1)
		{
			char c;
			i->get(c);
			if(c=='}'){return 0;}
			else if(c=='{'){n=0;}
			else if(n>=0){n++;s+=c;}	
		}
	}
};

}//end of namespace Rydot

#endif //__MESH_LOADER_H__

