
#include <stdlib.h>
#include <GL/glut.h>

#include <stdio.h>
#include <iostream>
#include <math.h>
#include <matrix.h>
#include <matrixutil.h>

#include <ryaux.h>

#include <windows.h>

#include "delauney.h"

#include "tetrahedron.h"

#include <glex/texture.h>

using namespace Rydot;

typedef std::vector<Vector2d> Vector2dv;

Texture tex[4],btn[3];

double pi=3.1415926535897932384626;

int maxtex=4;
int maxbtn=3;

class Face
{
public:
	int a,b,c;
	Vector2d pa,pb,pc;
	Face(){}
	Face(int _a,int _b,int _c,const Vector2d &_pa,const Vector2d &_pb,const Vector2d &_pc)
	:a(_a),b(_b),c(_c),pa(_pa),pb(_pb),pc(_pc){}
};

Vector3d vertex[]=
{
	Vector3d(1,1,1),
	Vector3d(-1,1,-1),
	Vector3d(-1,-1,1),
	Vector3d(1,-1,-1),
};

Vector2d ph[]=
{
	Vector2d(0,0),
	Vector2d(1,0),
	Vector2d(2,0),
	Vector2d(0,1),
	Vector2d(1,1),
	Vector2d(2,1),
};

Face faces[]=
{
	Face(0,1,2,ph[0],ph[1],ph[3]),
	Face(2,1,3,ph[3],ph[1],ph[4]),
	Face(3,1,0,ph[4],ph[1],ph[2]),
	Face(3,0,2,ph[4],ph[2],ph[5]),
};

class ButtonObj
{
public:
	Rect2d region;
	int active;
	int visible;
	int focus;

	ButtonObj(){}
	ButtonObj(Rect2d &r,int ac=1,int vis=1,int foc=0):region(r),active(ac),visible(vis),focus(foc){}

	int Mouse(Vector2d &v)
	{
		focus=0;
		if(region.In(v)&&active&&visible)
		{
				focus=1;
		}
		return focus;
	}
};

ButtonObj button[]=
{
	ButtonObj(Rect2d(0.5,1.75,1.5,2.05)),
	ButtonObj(Rect2d(1.6,1.75,2.6,2.05)),
	ButtonObj(Rect2d(-0.6,1.75,0.4,2.05)),
};

double faceangle=pi-2.0*asin(1.0/sqrt(3.0));//lʑ̖̂ʊԊp~=70.53deg

Vector3d transvertex[4];

Vector2d mousephase;

TekitohPhase tktph;

int tmp_mouse_x=320,tmp_mouse_y=240;
int downmouse_x=320,downmouse_y=240;

int drawing=0;
int rotating=0;

int width=640,height=480;

Quaterniond rot(0,0,0,1);

int counter=0;

int nn=0;
int mm=0;

int texnum;

int findcursor()
{
	double r=tan(20*0.5*3.141592/180)*12/(height*0.5);
	Vector3d p((tmp_mouse_x-width*0.5)*r,-(tmp_mouse_y-height*0.5)*r,0);

	//button check
	Vector2d b((tmp_mouse_x-width*0.5)*r,-(tmp_mouse_y-height*0.5)*r);

	for(int i=0;i<maxbtn;++i)
	{
		button[i].Mouse(b);
	}

	//find cursor
	int minid=-1;
	double mn=1e5;
	Vector3d mincoef;
	for(int i=0;i<4;i++)
	{
		Vector3d
			va=transvertex[faces[i].a],
			vb=transvertex[faces[i].b],
			vc=transvertex[faces[i].c],
			coef;
		ReflectTriangleRayTopology(Vector3d(0,0,10),p,va,vb,vc,coef);
		
		if(coef.x>=0&&coef.y>=0&&coef.x+coef.y<=1)
		{
			if(coef.z<mn)
			{
				mn=coef.z;
				minid=i;
				mincoef=coef;
			}
		}
	}

	if(minid>=0)
	{
		//make phase
		Face &f=faces[minid];
		mousephase=(f.pb-f.pa)*mincoef.x+(f.pc-f.pa)*mincoef.y+f.pa;
	}

	return minid;
}

void mousemove(int x,int y)
{
	tmp_mouse_x=x;tmp_mouse_y=y;

	int found=findcursor();

	if(rotating)
	{
		Quaterniond q1,q2;
		double ratio=0.005*480.0/height;
		q1.RotationAxis(Vector3d(0,1,0),(tmp_mouse_x-downmouse_x)*ratio);
		q2.RotationAxis(Vector3d(1,0,0),(tmp_mouse_y-downmouse_y)*ratio);

		downmouse_x=tmp_mouse_x;
		downmouse_y=tmp_mouse_y;

		rot=q1*q2*rot;

		//transform vertices
		for(int i=0;i<4;i++)
		{
			transvertex[i]=rot.Rotate(vertex[i]);
		}
	}

	if(drawing)
	{
		if(found>=0)
		{
			//append phase
			tktph.Append(mousephase);
		}
	}
}

void mouse(int button, int state, int x, int y)
{
	tmp_mouse_x=x;tmp_mouse_y=y;

	if(button==GLUT_LEFT_BUTTON)
	{
		if(state==GLUT_DOWN)
		{
			drawing=1;

			int found=findcursor();
			if(found>=0)
			{
				tktph.Append(mousephase);
			}

			if(::button[0].focus)//recut
			{
				tktph.Failure();
			}
			if(::button[1].focus)//reset
			{
				tktph.Clear();

				nn=0;
			}
			if(::button[2].focus)//tex
			{
				texnum++;
				texnum%=maxtex;
			}
		}
		else
		{
			drawing=0;

			if(tktph.recpolygons.empty())
			{
				tktph.Apply();

				if(tktph.SplitByFace())
				{
					counter=0;
				}
			}
		}
	}
	if(button==GLUT_RIGHT_BUTTON)
	{
		if(state==GLUT_DOWN)
		{
			downmouse_x=x;
			downmouse_y=y;
			rotating=1;

			if(::button[2].focus)//tex
			{
				texnum+=maxtex;
				texnum--;
				texnum%=maxtex;
			}

		}
		else
		{
			rotating=0;
		}
	}
}

void keyboard(unsigned char key, int x, int y)
{
	if(key==0x1b)//esc
	{
		tktph.Failure();
	}
	if(key=='r')
	{
		tktph.Clear();

		nn=0;
	}
	if(key=='\r')//enter
	{
		//tktph.SplitByFace();

		//counter=0;
	}
	if(key=='n')
	{
		nn++;
	}
	if(key=='m')
	{
		mm++;
	}

	if(key=='d')
	{
		time_t now;
		tm *tm_now;
		now = time(NULL);
		tm_now = localtime(&now);
		char str[256];
		int n=nn%tktph.recpolygons.size();
		sprintf(str,"delauneydbg%03d_%04d%02d%02d_%02d%02d%02d.txt",
			n,
			tm_now->tm_year+1900,tm_now->tm_mon+1,tm_now->tm_mday,
			tm_now->tm_hour, tm_now->tm_min, tm_now->tm_sec);
		tktph.SaveDelauney(str,n);
	}
}

void init()
{
	for(int i=0;i<4;i++)
	{
		transvertex[i]=vertex[i];
	}


	/*
	//FaceCross Test
	Vector2d p[4]={
		Vector2d(.2,.2),
		Vector2d(.8,.8),
		Vector2d(1.2,.2),
		Vector2d(1.8,.8)
	};
	for(int i=0;i<4;++i)
	{
		for(int j=0;j<4;++j)
		{
			if(i==j)continue;
			Vector2d c,d;
			CheckFaceCross(p[i],p[j],c,d);
			std::cout<<p[i]<<"/"<<p[j]<<"/"<<c<<"/"<<d<<std::endl;
		}
	}*/


	tex[0].LoadFile("tex1.png",CLIP_REPEAT);
	tex[1].LoadFile("tex2.png",CLIP_REPEAT);
	tex[2].LoadFile("tex3.png",CLIP_REPEAT);
	tex[3].LoadFile("tex4.png",CLIP_REPEAT);

	btn[0].LoadFile("recut.png");
	btn[1].LoadFile("reset.png");
	btn[2].LoadFile("texturebutton.png");
}

void animate()
{

	button[0].visible=tktph.recpolygons.empty()?1:0;
	button[0].active=tktph.presentedge.Empty()?0:1;
	button[1].active=(tktph.validedges.empty()&&tktph.presentedge.Empty())?0:1;


	glutPostRedisplay();
}



Vector3f col[]=
{
	Vector3f(.9,.3,.3),
	Vector3f(.3,.9,.3),
	Vector3f(.3,.3,.9),
	Vector3f(.9,.9,.3),
};


//Ђ炢Ƃ肷
//param: 0->spread 1->close
//pos:WJ}uʒu
//orgpos:̈ʒu
//orgsc:̃TCY
void drawspread(double param,Vector2i pos,Vector3d orgpos,double orgsc,int linemode=0)
{
	if(tktph.recpolygons.empty())return;




	intv stk,tgt;
	stk.push_back(0);
	tgt.push_back(0);

	//WJƂ̃TCY
	double minsz=0.40;

	glPushMatrix();

	Quaterniond nor(0,0,0,1);

	//WJʒu
	if(pos.y&1)
	{
		glTranslated((1-param)*(pos.x*2.0+(pos.y-1)*0.5)*minsz,(1-param)*((pos.y-1)*sqrt(3.0)/2.0)*minsz,(1-param)*-3.0);
		glTranslated((1-param)*1.0*minsz,-(1-param)*sqrt(3.0)/3.0*minsz,0);
		glRotated((1-param)*180,0,0,1);
	}
	else
	{
		glTranslated((1-param)*(pos.x*2.0+pos.y*0.5)*minsz,(1-param)*(pos.y*sqrt(3.0)/2.0)*minsz,(1-param)*-3.0);
	}

	//ƈʒu
	Vector3d pp=orgpos*param;
	glTranslated(pp.x,pp.y,pp.z);

	Quaterniond rr;
	Quaterniond ra,rb;

	ra.RotationAxis(Vector3d(1,1,0),-faceangle*0.5);
	rb.RotationAxis(Vector3d(0,0,1),165.0/180.0*pi);

	Quaterniond interpolate=Quaterniond::Slerp(nor,rot*ra*rb,param);

	double m[16];
	interpolate.ToRotMatrix33().ToArray44(m);
	glMultMatrixd(m);

	double osc=(orgsc-1)*(param)+1;
	glScaled(osc,osc,osc);

	glTranslated(0,0,sqrt(1.0/3.0));
	double trt=2.0*sqrt(2.0);//*(param+1)*0.5;
	double sc=(trt-minsz)*(param)+minsz;
	glScaled(sc,sc,-sc);

	glPushMatrix();



	int cnt=0;

	//glEnable(GL_DEPTH_TEST);
	//glDepthMask(1);

	//glDisable(GL_BLEND);

	//std::cout<<"---"<<std::endl;

	while(!tgt.empty())
	{
		int s=stk.back();
		int t=tgt.back();

		if(t==0)
		{
			const RecPolygon &rp=tktph.recpolygons[s];
			const TransformTree &tt=tktph.tts[s];

			double param2=pow(param,cnt+1.0);

			if(s!=0)
			{
				glRotated(-tt.rotate_alpha*180.0/pi,0,0,1);
				glTranslated(0,tt.offset_radius,0);
				glRotated(param2*faceangle*180.0/pi,1,0,0);
				glTranslated(0,tt.offset_radius,0);
				glRotated(-tt.rotate_beta*180.0/pi,0,0,1);
			}

			glPushMatrix();

			glTranslated(tt.offset_center.x,tt.offset_center.y,0);
			double m[16];
			tt.shear.Transp().ToArray44(m);
			glMultMatrixd(m);
			glTranslated(tt.offset_phase.x,tt.offset_phase.y,0);

			//Quaternionf c(col[rp.face]);
			//c.w=0.5;
			//glColor4fv((float*)&c);
			//glColor3f(1,1,1);

			if(!linemode)
			{
				glBegin(GL_TRIANGLES);
				for(int i=0;i<rp.tris.size();++i)
				{
					int j;
					j=rp.tris[i].p1;
					{
						Vector2d a=rp.p[j];
						Vector3d pa(a.x,a.y,0);
						Vector2d ta(a.x*0.5,1-a.y);
						glTexCoord2dv((double*)&ta);
						glVertex3dv((double*)&pa);
					}
					j=rp.tris[i].p3;
					{
						Vector2d a=rp.p[j];
						Vector3d pa(a.x,a.y,0);
						Vector2d ta(a.x*0.5,1-a.y);
						glTexCoord2dv((double*)&ta);
						glVertex3dv((double*)&pa);
					}
					j=rp.tris[i].p2;
					{
						Vector2d a=rp.p[j];
						Vector3d pa(a.x,a.y,0);
						Vector2d ta(a.x*0.5,1-a.y);
						glTexCoord2dv((double*)&ta);
						glVertex3dv((double*)&pa);
					}
				}
				glEnd();
			}
			else
			{
				glBegin(GL_LINES);
				for(int i=0;i<rp.edges.size();++i)
				{
					int j;
					j=rp.edges[i].p1;
					{
						Vector2d a=rp.p[j];
						Vector3d pa(a.x,a.y,0);
						Vector2d ta(a.x*0.5,1-a.y);
						//glTexCoord2dv((double*)&ta);
						glVertex3dv((double*)&pa);
					}
					j=rp.edges[i].p2;
					{
						Vector2d a=rp.p[j];
						Vector3d pa(a.x,a.y,0);
						Vector2d ta(a.x*0.5,1-a.y);
						//glTexCoord2dv((double*)&ta);
						glVertex3dv((double*)&pa);
					}
				}
				glEnd();
			}

			glPopMatrix();
		}

		if(t>=tktph.tts[s].child.size())
		{
			stk.pop_back();
			tgt.pop_back();
			glPopMatrix();
			cnt--;
		}
		else
		{
			int u=tktph.tts[s].child[t];

			stk.push_back(u);
			tgt.back()++;
			tgt.push_back(0);

			cnt++;
			glPushMatrix();
		}
	}
	glPopMatrix();
	glPopMatrix();
	
	//glDisable(GL_TEXTURE_2D);
	//glDisable(GL_BLEND);
}



void disp()
{
	// ʂ
	glDepthMask(1);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	//double r=tan(25*0.5*3.141592/180)*10/(height*0.5);
	//Vector3d p((tmp_mouse_x-width*0.5)*r,-(tmp_mouse_y-height*0.5)*r,0);
	
	static int tt;
	tt++;
	double ang=tt*0.2;



	//Vector2i pos(0,0);

	Vector2i wh=tktph.region.Diagonal();

	++wh.x;
	++wh.y;

	if(wh.x<=2)wh.x=2;
	if(wh.y<=3)wh.y=3;

	int ww=wh.x*2+1,hh=wh.y*2;

	static int lasttime=0;
	int timevalue=GetTickCount();
	int dt=timevalue-lasttime;
	if(dt>100)dt=100;
	lasttime=timevalue;

	double param=cos(counter*0.0020/ww/hh);
	param*=param;
	counter+=dt;

	int wmh=ww*hh;

	int aa=param*(ww*hh*0.5+1.0)+0.5;
	double rr=param*(ww*hh*0.5+1.0)+0.5-aa;
	rr=pow(rr,0.7);
	aa--;

	int bb=param*(ww*hh*0.5+1.0)+0.0;
	double rr2=param*(ww*hh*0.5+1.0)+0.0-bb;
	rr2=pow(rr2,0.7);
	bb--;

	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);
	tex[texnum].Activate();
	glEnable(GL_DEPTH_TEST);
	glDepthMask(1);

	int k=0;

	double modecoef=1-exp(-counter*0.01);
	Vector3d orgpos(-1.5*modecoef,1*modecoef,0);
	double orgsc=(0.4-1.0)*modecoef+1;

	for(int j=-wh.x;j<=wh.x;++j)
	{
		for(int i=-wh.y+1;i<=wh.y;++i)
		{
			int chk=0;
			double rr3;
			if(k&1){chk=bb;rr3=rr2;}else{chk=aa;rr3=rr;}
			//if(aa==k)
			if(chk==k/2)
			{
				glEnable(GL_CULL_FACE);
				glCullFace(GL_FRONT);
				glColor3f(.4,.4,.4);
				glEnable(GL_TEXTURE_2D);
				drawspread(rr3,Vector2i(j,i),orgpos,orgsc);
				glCullFace(GL_BACK);
				glColor3f(1,1,1);
				drawspread(rr3,Vector2i(j,i),orgpos,orgsc);
			}
			//if(aa>nn)
			//	drawspread(1,Vector2i(j,i));
			//if(aa<k)
			else if(chk<k/2)
			{
				if( (i&1) && (j&1) )
				{
					glColor3f(.85,.85,.85);
				}
				else if( !(i&1) && (j&1) )
				{
					glColor3f(.55,.55,.55);
				}
				else if( !(i&1) && !(j&1) )
				{
					glColor3f(1,1,1);
				}
				else
				{
					glColor3f(.7,.7,.7);
				}
				glEnable(GL_TEXTURE_2D);
				drawspread(0,Vector2i(j,i),orgpos,orgsc);
				glColor4f(1,1,1,.5);
				glEnable(GL_BLEND);
				glEnable(GL_LINE_SMOOTH);
				glLineWidth(1.1);
				glDisable(GL_TEXTURE_2D);
				drawspread(0,Vector2i(j,i),orgpos,orgsc,1);
				glDisable(GL_BLEND);
			}
			k++;
		}
	}
	
	glDisable(GL_TEXTURE_2D);

	//drawspread(1,Vector2i(0,0),Vector3d(-1.5,1,0),0.5);

	glDisable(GL_LINE_SMOOTH);
	glDisable(GL_BLEND);
	glDisable( GL_POLYGON_OFFSET_FILL );

	glLineWidth(1.0);

	glDepthMask(0);
	
	//WJ}(?)̃Obhƃ}EX|Cg
/*	{
		glColor3f(1,1,1);
		
		glPushMatrix();
		
		glTranslatef(1.5,1.0,0);
		glScalef(.5,.5,1);
		
		glBegin(GL_LINE_STRIP);
		
		glVertex3f(0,0,0);
		glVertex3f(0,1,0);
		glVertex3f(1,0,0);
		glVertex3f(1,1,0);
		glVertex3f(2,0,0);
		glVertex3f(2,1,0);
		
		glEnd();
		
		glPointSize(3);
		
		glBegin(GL_POINTS);
		
		glVertex2dv((double*)&mousephase);
		
		glEnd();
		
		glPopMatrix();
	}




	//valid edge
	//LGbW
	//WJ}ɕ\
	glDisable(GL_DEPTH_TEST);
	glColor3f(1,1,1);
	glDepthMask(1);
	//for(int m=-2;m<=2;m++)//y
	{
		//for(int n=-2;n<=2;n++)//x
		{
			int m=0,n=0;
			glPushMatrix();
			glTranslatef(1.5,1.0,0);
			glScalef(.5,.5,1);
			glTranslatef(n*2+1,m+0.5,0);
			if(m&1)
			{
				glRotatef(180,0,0,1);
			}
			glTranslatef(-1,-0.5,0);
			glBegin(GL_LINES);
			for(int i=0;i<tktph.validedges.size();++i)
			{
				Edge &e=tktph.validedges[i];
				for(int j=0;j<e.pedges.size();++j)
				{
					if(e.pedges[j].face==-1)continue;
					glVertex2dv((double*)&e.points[e.pedges[j].a]);
					glVertex2dv((double*)&e.points[e.pedges[j].b]);
				}
			}
			glEnd();
			glPopMatrix();
		}
	}
	glEnable(GL_DEPTH_TEST);






	//}`WJ}ɕ\
	glDisable(GL_DEPTH_TEST);
	//if(!tktph.recpolygons.empty())
	for(int m=0;m<tktph.recpolygons.size();++m)
	{
		int n=nn%tktph.recpolygons.size();
		const RecPolygon &rp=tktph.recpolygons[m];
		glPushMatrix();
		
		glTranslatef(1.5,1.0,0);
		glScalef(.5,.5,1);


		int x=rp.offset.x,y=rp.offset.y;

			glTranslatef(x*2+1,y+0.5,0);
			if(y&1)
			{
				glRotatef(180,0,0,1);
			}
			glTranslatef(-1,-0.5,0);

		glBegin(GL_LINE_STRIP);

		if(m==n)
			glColor3f(1,0,0);
		else
			glColor3f(0,1,0);

		if(!rp.p.empty())
		for(int i=0;i<=rp.p.size();++i)
		{
			int j=i%rp.p.size();
			glVertex2dv((double*)&rp.p[j]);
		}
		glEnd();
		glPopMatrix();

	}
	glEnable(GL_DEPTH_TEST);

*/





	//̂ɕ\

	glPushMatrix();
	if(!tktph.recpolygons.empty())
	{
		//double modecoef=1-exp(-count*0.01);
		//glTranslated(-1.5*modecoef,1*modecoef,0);
		//double sc=(0.4-1.0)*modecoef+1;
		//glScaled(sc,sc,sc);

		glTranslated(orgpos.x,orgpos.y,orgpos.z);
		glScaled(orgsc,orgsc,orgsc);
	}


	//present drawing
	glLineWidth(2.0);
	glPointSize(5.0);

	glColor3f(1,1,1);
	glDisable(GL_BLEND);
	glDepthMask(1);


	glBegin(GL_LINE_STRIP);

	glLineWidth(5.0);
	glColor3f(1,.2,.2);
	for(int i=0;i<tktph.presentedge.points.size();i++)
	{
		Vector2d a=tktph.presentedge.points[i];
		int fa=CheckFace(a);
		Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
		Vector2d aa=ma.Solve(a-faces[fa].pa);
		Vector3d pa=
			(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
			(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
			transvertex[faces[fa].a];
		glVertex3dv((double*)&pa);
	}
	glEnd();
	

	//validedge
	glLineWidth(2.0);
	//glColor3f(1,1,1);
	for(int n=0;n<tktph.validedges.size();++n)
	{
		glColor3f(.4,.4,.4);

		if(!tktph.presentedge.Empty())
		{
			if(!tktph.EndableEdge(n))//_Ȑ؂
			{
				glColor3f(.6,.8,.8);
			}
		}



		glBegin(GL_LINE_STRIP);
		for(int i=0;i<tktph.validedges[n].points.size();++i)
		{
			Vector2d a=tktph.validedges[n].points[i];
			int fa=CheckFace(a);
			Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
			Vector2d aa=ma.Solve(a-faces[fa].pa);
			Vector3d pa=
				(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
				(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
				transvertex[faces[fa].a];
			glVertex3dv((double*)&pa);
		}
		glEnd();
	}




	int startablevertex=tktph.Startable(mousephase);

	static int laststartable=-1;
	static int startableanim=0;
	
	startableanim++;

	if(laststartable!=startablevertex)
	{
		startableanim=0;
		laststartable=startablevertex;
	}

	//vertex circle
	for(int i=0;i<4;i++)
	{
		int N=16;

		glLineWidth(2.0);

		static const Vector3f col[]=
		{
			Vector3f(.4,.4,.4),
			Vector3f(1,.4,.4),
			Vector3f(.4,1,.4),
			Vector3f(.4,.4,1),
			Vector3f(1,1,0),
		};

		int u=tktph.vertexused[i];

		if(u>3)u=4;

		glColor3fv((float*)&col[u]);

		double radius=1.0;

		if(startablevertex==i)
		{
			radius=(fabs(sin(startableanim*0.1))*0.3+1);
		}
		else if(tktph.EndableVertex(i))
		{
			radius=(fabs(sin(startableanim*0.1))*0.3+1);
		}

		glBegin(GL_LINE_STRIP);
		for(int k=0;k<=N;k++)
		{
			double c=cos(k*3.141592*2/N)*radius,s=sin(k*3.141592*2/N)*radius;
			Vector3d p=transvertex[i]+Vector3d(c*0.2,s*0.2,0);
			glVertex3dv((double*)&p);
		}
		glEnd();

	}






	//Ȏlʑ
	glEnable(GL_CULL_FACE);
	
	glEnable( GL_POLYGON_OFFSET_FILL );
	glPolygonOffset(1.0,1.0);
	glDepthMask(0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_TEXTURE_2D);

	Vector2d texcoord[6]=
	{
		Vector2d(0,1),Vector2d(.5,1),Vector2d(1,1),
		Vector2d(0,0),Vector2d(.5,0),Vector2d(1,0),
	};
	int texface[12]=
	{
		0,1,3,
		3,1,4,
		4,1,2,
		4,2,5,
	};

	glBegin(GL_TRIANGLES);
	for(int i=0;i<4;i++)
	{
		/*Quaternionf c(col[i]);
		c.w=0.7;
		glColor4fv((float*)&c);*/

		glColor4f(.9,.9,.9,.7);
		
		glTexCoord2dv((double*)&texcoord[texface[i*3+0]]);
		glVertex3dv((double*)&transvertex[faces[i].a]);
		glTexCoord2dv((double*)&texcoord[texface[i*3+1]]);
		glVertex3dv((double*)&transvertex[faces[i].b]);
		glTexCoord2dv((double*)&texcoord[texface[i*3+2]]);
		glVertex3dv((double*)&transvertex[faces[i].c]);
	}
	glEnd();

	glDisable(GL_TEXTURE_2D);
	glDisable( GL_POLYGON_OFFSET_FILL );
	glDisable(GL_BLEND);
	glDepthMask(1);




	//loop, midpoint
	glPointSize(5.0);
	glLineWidth(2.0);
	glColor3f(0,1,1);
	int sz=tktph.mid.size();
	if(sz>0)
	{
/*		int n=nn%tktph.loop.size();

		glBegin(GL_POINTS);

		for(int i=0;i<tktph.loop[n].size();++i)
		{

			if(i==mm%tktph.loop[n].size())
			{
				glColor3f(1,0,0);		
			}
			else
			{
				glColor3f(0,1,1);
			}

			int s=tktph.loop[n][i]/sz;
			Vector2d a=tktph.mid[s].first;
//			Vector2d a=tktph.mid[n].first;
			int fa=CheckFace(a);
			Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
			Vector2d aa=ma.Solve(a-faces[fa].pa);
			Vector3d pa=
				(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
				(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
				transvertex[faces[fa].a];
			glVertex3dv((double*)&pa);
		}
		
		glEnd();*/

		//loop
/*		int fc=tktph.loopface[n];
		std::vector<int> edgeused(tktph.splitededges[fc].size());
		for(int i=0;i<tktph.loop[n].size();++i)
		{
			int a=tktph.loop[n][i]/sz;
			int b=tktph.loop[n][i]%sz;
			//find
			int found=-1;
			for(int k=0;k<tktph.splitededges[fc].size();++k)
			{
				if(edgeused[k])continue;
				if( (tktph.splitededges[fc][k].r1==a&&tktph.splitededges[fc][k].r2==b)
					||(tktph.splitededges[fc][k].r2==a&&tktph.splitededges[fc][k].r1==b) )
				{
					found=k;
					break;
				}
			}

			if(found<0)continue;
			edgeused[found]=1;

			glBegin(GL_LINE_STRIP);
			Edge &e=tktph.splitededges[fc][found];
			for(int j=0;j<e.points.size();++j)
			{
				Vector2d a=e.points[j];
				int fa=CheckFace(a);
				Matrix22f ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
				Vector2d aa=ma.Solve(a-faces[fa].pa);
				Vector3f pa=
					(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
					(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
					transvertex[faces[fa].a];
				glVertex3fv((float*)&pa);
			}
			glEnd();
		}*/


		//recpolygon
		const RecPolygon &rp=tktph.recpolygons[nn%tktph.recpolygons.size()];


/*		glBegin(GL_LINE_STRIP);

		if(!rp.p.empty())
		for(int i=0;i<=rp.p.size();++i)
		{
			glColor3f( (i%5)/4.0, ((i/5)%5)/4.0, ((i/25)%5)/4.0 );
			{
				int j=i%rp.p.size();
				Vector2d a=rp.p[j];
				int fa=CheckFace(a);
				Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
				Vector2d aa=ma.Solve(a-faces[fa].pa);
				Vector3d pa=
					(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
					(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
					transvertex[faces[fa].a];
				glVertex3dv((double*)&pa);
			}
		}
		glEnd();*/





		//recorded ploygon
/*		glBegin(GL_TRIANGLES);
		for(int i=0;i<rp.tris.size();++i)
		{
			//glColor3f( (i%5)/4.0, ((i/5)%5)/4.0, ((i/25)%5)/4.0 );
			glColor3fv((float*)&col[rp.face]);
			int j;
			j=rp.tris[i].p1;
			{
				Vector2d a=rp.p[j];
				int fa=CheckFace(a);
				Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
				Vector2d aa=ma.Solve(a-faces[fa].pa);
				Vector3d pa=
					(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
					(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
					transvertex[faces[fa].a];
				glVertex3dv((double*)&pa);
			}
			j=rp.tris[i].p3;
			{
				Vector2d a=rp.p[j];
				int fa=CheckFace(a);
				Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
				Vector2d aa=ma.Solve(a-faces[fa].pa);
				Vector3d pa=
					(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
					(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
					transvertex[faces[fa].a];
				glVertex3dv((double*)&pa);
			}
			j=rp.tris[i].p2;
			{
				Vector2d a=rp.p[j];
				int fa=CheckFace(a);
				Matrix22d ma(faces[fa].pb-faces[fa].pa,faces[fa].pc-faces[fa].pa);
				Vector2d aa=ma.Solve(a-faces[fa].pa);
				Vector3d pa=
					(transvertex[faces[fa].b]-transvertex[faces[fa].a])*aa.x+
					(transvertex[faces[fa].c]-transvertex[faces[fa].a])*aa.y+
					transvertex[faces[fa].a];
				glVertex3dv((double*)&pa);
			}
		}
		glEnd();*/





	


	}


	glPopMatrix();


	//draw button

	for(int i=0;i<maxbtn;i++)
	{
		if(!button[i].visible)continue;

		glPushMatrix();

		Vector2d p1=button[i].region.p1;
		Vector2d dia=button[i].region.Diagonal();
		glTranslatef(p1.x,p1.y,0);
		glScalef(dia.x,dia.y,1.0);

		if(button[i].active)
		{
			if(button[i].focus)
				glColor3f(1,1,1);
			else
				glColor4f(1,1,1,.7);
		}
		else
		{
			glColor4f(.5,.5,.5,.7);
		}

		btn[i].Activate();
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBegin(GL_QUADS);
		glTexCoord2f(0,1);
		glVertex3f(0,0,0);
		glTexCoord2f(1,1);
		glVertex3f(1,0,0);
		glTexCoord2f(1,0);
		glVertex3f(1,1,0);
		glTexCoord2f(0,0);
		glVertex3f(0,1,0);
		glEnd();
		glPopMatrix();
	}








	glutSwapBuffers();
	
	Sleep(1);
}

void resize(int w,int h)
{
	width=w;
	height=h;

	glViewport(0,0,w,h);

	// e@̐ݒ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(
		20,             // p
		(float)w/(float)h,    // AXyNg
		0.1,            // p̋߂ق̋
		20             // ق̋
	);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(
		0.0, 0.0, 12.0,    // _
		0.0, 0.0, 0.0,    // ʒu
		0.0, 1.0, 0.0     // ̏̕
	);
}

int main(int argc,char **argv)
{
	// 
	glutInit(&argc,argv);
	glutInitWindowPosition(100, 50);
	glutInitWindowSize(640, 480);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);

	glutCreateWindow("lʑ̓WJ~l");
	glutDisplayFunc(disp);
	glutIdleFunc(animate);
	glutMotionFunc(mousemove);
	glutPassiveMotionFunc(mousemove);
	glutMouseFunc(mouse);
	glutKeyboardFunc(keyboard);
	glutReshapeFunc(resize);

	init();
	
	// wiF
	glClearColor(0.9,0.9,0.9,1.0);
	// seXg
	glEnable(GL_DEPTH_TEST);
	// ʂ\Ȃ
	glEnable(GL_CULL_FACE);

	// J̐ݒ

	// e@̐ݒ
	glMatrixMode(GL_PROJECTION);
	gluPerspective(
		20,             // p
		640.0/480.0,    // AXyNg
		0.1,            // p̋߂ق̋
		100             // ق̋
	);

	// W̐ݒ
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(
		0.0, 0.0, 12.0,    // _
		0.0, 0.0, 0.0,    // ʒu
		0.0, 1.0, 0.0     // ̏̕
	);

	// C[v
	glutMainLoop();
	return 0;
}
